Index: trunk/Cosmo/SimLSS/agnjackson.cc
===================================================================
--- trunk/Cosmo/SimLSS/agnjackson.cc	(revision 3614)
+++ trunk/Cosmo/SimLSS/agnjackson.cc	(revision 3615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include <iostream>
Index: trunk/Cosmo/SimLSS/cmvobserv3d.cc
===================================================================
--- trunk/Cosmo/SimLSS/cmvobserv3d.cc	(revision 3614)
+++ trunk/Cosmo/SimLSS/cmvobserv3d.cc	(revision 3615)
@@ -7,7 +7,11 @@
 #include <math.h>
 #include <unistd.h>
+#include "sophyainit.h"
 #include "timing.h"
 #include "ntuple.h"
 #include "matharr.h"
+#include "randfmt.h"
+//#include "randr48.h"
+#include "srandgen.h"
 
 #include "constcosmo.h"
@@ -71,4 +75,5 @@
 int main(int narg,char *arg[])
 {
+ SophyaInit();
  InitTim();
 
@@ -146,4 +151,11 @@
  system("date -u");
 
+ // --- Choix du generateur aleatoire (a faire ICI imperativement avant AutoInitRand)
+ FMTRandGen *RandGen = new FMTRandGen;
+ RandGen->SelectGaussianAlgo(C_Gaussian_RandLibSNorm);
+ RandGen->SelectPoissonAlgo(C_Poisson_Ahrens);
+ RandomGeneratorInterface::SetGlobalRandGenP(RandGen);
+ 
+ // --- Decodage des arguments
  char c;
  while((c = getopt(narg,arg,"ha0PWSV2U:G:F:x:y:z:s:Z:M:A:T:N:Q:R:8:O:o:")) != -1) {
@@ -151,5 +163,5 @@
   switch (c) {
   case 'a' :
-    Auto_Ini_Ranf(5);
+    AutoInitRand(5);
     break;
   case '0' :
@@ -262,4 +274,6 @@
      <<whattowrt[4]<<endl;
  cout<<"rootnameout="<<rootnameout<<endl;
+ ShowRandom();
+ cout<<"   First random is: "<<drand01()<<endl;
 
  string tagobs = rootnameout + ".ppf";
@@ -772,5 +786,8 @@
  }
 
+ //-----------------------------------------------------------------
+ delete RandGen;
  PrtTim(">>>> End Of Job");
+
  return 0;
 }
Index: trunk/Cosmo/SimLSS/cmvschdist.cc
===================================================================
--- trunk/Cosmo/SimLSS/cmvschdist.cc	(revision 3614)
+++ trunk/Cosmo/SimLSS/cmvschdist.cc	(revision 3615)
@@ -17,7 +17,10 @@
 #include <math.h>
 #include <unistd.h>
+#include "sophyainit.h"
 #include "timing.h"
 #include "histos.h"
 #include "ntuple.h"
+//#include "randr48.h"
+#include "randfmt.h"
 #include "srandgen.h"
 #include "perandom.h"
@@ -46,4 +49,5 @@
 int main(int narg,char *arg[])
 {
+SophyaInit();
  double h75 = 0.71 / 0.75;
  double nstar = 0.006*pow(h75,3.);  //  
@@ -62,4 +66,11 @@
  string nametoppf = "";
 
+ // --- Choix du generateur aleatoire (a faire ICI imperativement avant AutoInitRand)
+ FMTRandGen *RandGen = new FMTRandGen;
+ RandGen->SelectGaussianAlgo(C_Gaussian_RandLibSNorm);
+ RandGen->SelectPoissonAlgo(C_Poisson_Ahrens);
+ RandomGeneratorInterface::SetGlobalRandGenP(RandGen);
+
+ // --- decodage des arguments
  char c;
  while((c = getopt(narg,arg,"h0avm:N:n:r:R:W:")) != -1) {
@@ -99,5 +110,5 @@
      break;
    case 'a' :
-     Auto_Ini_Ranf(5);
+     AutoInitRand(5);
      break;
    case 'h' :
@@ -201,4 +212,6 @@
  }
 
+ delete RandGen;
+
  PrtTim("End of Job");
 
Index: trunk/Cosmo/SimLSS/cmvtstagn.cc
===================================================================
--- trunk/Cosmo/SimLSS/cmvtstagn.cc	(revision 3614)
+++ trunk/Cosmo/SimLSS/cmvtstagn.cc	(revision 3615)
@@ -8,4 +8,5 @@
 #include <math.h>
 #include <unistd.h>
+#include "sophyainit.h"
 #include "timing.h"
 #include "ntuple.h"
@@ -13,4 +14,5 @@
 #include "geneutils.h"
 #include "agnjackson.h"
+#include "srandgen.h"
 
 void usage(void);
@@ -27,4 +29,5 @@
 int main(int narg,char *arg[])
 {
+SophyaInit();
  double angsol = 1.;  // sr
  double lxmin=-3.,lxmax=4.; int nbinlx = -100;
@@ -100,5 +103,5 @@
    for(long i=0;i<npix;i++) {
      if(i%l==0) cout<<"...trial: "<<i<<endl;
-     unsigned long n = PoissRandLimit(mu,10.);
+     uint_8 n = Poisson(mu,10.);
      hnobj.Add((double)n);
      sumn += n; sumn2 += n*n;
Index: trunk/Cosmo/SimLSS/cmvtstsch.cc
===================================================================
--- trunk/Cosmo/SimLSS/cmvtstsch.cc	(revision 3614)
+++ trunk/Cosmo/SimLSS/cmvtstsch.cc	(revision 3615)
@@ -7,4 +7,5 @@
 #include <math.h>
 #include <unistd.h>
+#include "sophyainit.h"
 #include "timing.h"
 #include "histos.h"
@@ -35,4 +36,5 @@
 int main(int narg,char *arg[])
 {
+SophyaInit();
  double h75 = 0.71 / 0.75;
  double nstar = 0.006*pow(h75,3.);  //  
@@ -66,5 +68,5 @@
      break;
    case 'a' :
-     Auto_Ini_Ranf(5);
+     AutoInitRand(5);
      break;
    case 'h' :
Index: trunk/Cosmo/SimLSS/genefluct3d.cc
===================================================================
--- trunk/Cosmo/SimLSS/genefluct3d.cc	(revision 3614)
+++ trunk/Cosmo/SimLSS/genefluct3d.cc	(revision 3615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include <iostream>
@@ -693,5 +694,5 @@
        // Explication de la division par 2: voir perandom.cc
        // ou egalement Coles & Lucchin, Cosmology formula 13.7.2 p279
-       T_(l,j,i) = ComplexGaussRan(sqrt(pk/2.));
+       T_(l,j,i) = ComplexGaussian(sqrt(pk/2.));
      }
    }
@@ -1346,5 +1347,5 @@
    double v = data_[ip];
    if(v>0.) {
-     unsigned long dn = PoissRandLimit(v,10.);
+     uint_8 dn = Poisson(v,10.);
      data_[ip] = (double)dn;
      sum += (double)dn;
Index: trunk/Cosmo/SimLSS/geneutils.cc
===================================================================
--- trunk/Cosmo/SimLSS/geneutils.cc	(revision 3614)
+++ trunk/Cosmo/SimLSS/geneutils.cc	(revision 3615)
@@ -1,2 +1,3 @@
+#include "sopnamsp.h"
 #include "machdefs.h"
 #include <iostream>
Index: trunk/FrEROS/AnaLC/nbgene.cc
===================================================================
--- trunk/FrEROS/AnaLC/nbgene.cc	(revision 3614)
+++ trunk/FrEROS/AnaLC/nbgene.cc	(revision 3615)
@@ -1,3 +1,4 @@
 #include "machdefs.h"
+#include "sopnamsp.h"  // using SOPHYA namespace
 #include <stdio.h>
 #include <stdlib.h>
@@ -6,9 +7,9 @@
 #include "fsvcache.h"
 #include "nbtri.h"
-#include "nbrandom.h"
 #include "nbmath.h"
 #include "nbinteg.h"
 #include "strutil.h"
 #include "fsvst.h"
+#include "srandgen.h"
 #include "nbsread.h"
 #include "nbgene.h"
@@ -68,5 +69,5 @@
   seed_16v[1]=(unsigned short) mc.iseed2;
   seed_16v[2]=(unsigned short) mc.iseed3;
-  Ini_Ranf(seed_16v,0);
+  RandGen->SetSeed(seed_16v);
 
   mc.NGene = mc.NPoints_ampli = mc.NPoints_ampli_tf = mc.Net_ampli_tf = 0;
@@ -238,5 +239,5 @@
   printf("Nb d'etoiles amplifiees avec taille finie %d\n"
         ,mc.Net_ampli_tf);
-  Get_Ranf(seed_16v,0);
+  RandGen->SetSeed(seed_16v);
   mc.iseed1 = (int_4)seed_16v[0];
   mc.iseed2 = (int_4)seed_16v[1];
Index: trunk/FrEROS/AnaLC/nbsread.cc
===================================================================
--- trunk/FrEROS/AnaLC/nbsread.cc	(revision 3614)
+++ trunk/FrEROS/AnaLC/nbsread.cc	(revision 3615)
@@ -1,4 +1,5 @@
 /* lecture des fichiers de suivi:     cmv 21/12/93 */
 #include "machdefs.h"
+#include "sopnamsp.h"  // using SOPHYA namespace
 #include <stdio.h>
 #include <stdlib.h>
@@ -7,7 +8,7 @@
 #include <signal.h>
 
+#include "sophyainit.h"
 #include "fsvcache.h"
 #include "nbtri.h"
-#include "nbrandom.h"
 #include "nbmath.h"
 #include "strutil.h"
@@ -106,4 +107,12 @@
 if (narg < 2) usage(0);
 if( !strcmp(arg[1],"-h") != 0 ) usage(1);
+
+/*------------------------------------------*/
+/*-------- Initialisation Aleatoire --------*/
+/*------------------------------------------*/
+ SophyaInit();
+ RandGen = new DR48RandGen;
+ RandomGeneratorInterface::SetGlobalRandGenP(RandGen);
+
 
 /*------------------------------------------*/
@@ -417,6 +426,7 @@
 
 printf("Nombre total d'etoiles lues %d\n",netoiles);
-
-exit(0);
+delete RandGen;
+
+return(0);
 }
 
Index: trunk/FrEROS/AnaLC/nbsread.h
===================================================================
--- trunk/FrEROS/AnaLC/nbsread.h	(revision 3614)
+++ trunk/FrEROS/AnaLC/nbsread.h	(revision 3615)
@@ -25,7 +25,9 @@
 
 #include <stdio.h>
+#include "randr48.h"
 #include "fsvcache.h"
 
 /* valeurs de control */
+EXTERN DR48RandGen * RandGen;
 
 EXTERN double GRAND2_KILL;
Index: trunk/FrEROS/AnaLC/nbsreadu_squel.cc
===================================================================
--- trunk/FrEROS/AnaLC/nbsreadu_squel.cc	(revision 3614)
+++ trunk/FrEROS/AnaLC/nbsreadu_squel.cc	(revision 3615)
@@ -4,4 +4,5 @@
 */
 #include "machdefs.h"
+#include "sopnamsp.h"  // using SOPHYA namespace
 #include <stdlib.h>
 #include <math.h>
Index: trunk/SophyaExt/FitsIOServer/Makefile
===================================================================
--- trunk/SophyaExt/FitsIOServer/Makefile	(revision 3614)
+++ trunk/SophyaExt/FitsIOServer/Makefile	(revision 3615)
@@ -48,4 +48,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -77,4 +78,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -105,4 +107,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h fabtcolread.h \
@@ -151,4 +154,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h fitshandler.h \
@@ -255,4 +259,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h fitsblkrw.h \
@@ -288,4 +293,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h fitsblkrw.h \
@@ -319,4 +325,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -353,4 +360,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -419,4 +427,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h fitsfile.h \
@@ -504,4 +513,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -547,4 +557,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -577,5 +588,6 @@
   $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h fitsfile.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h fitsfile.h \
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)dvlist.h fitsinoutfile.h \
@@ -607,4 +619,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
Index: trunk/SophyaExt/FitsIOServer/smakefile
===================================================================
--- trunk/SophyaExt/FitsIOServer/smakefile	(revision 3614)
+++ trunk/SophyaExt/FitsIOServer/smakefile	(revision 3615)
@@ -48,4 +48,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -77,4 +78,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -105,4 +107,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h fabtcolread.h \
@@ -151,4 +154,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h fitshandler.h \
@@ -255,4 +259,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h fitsblkrw.h \
@@ -288,4 +293,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h fitsblkrw.h \
@@ -319,4 +325,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -353,4 +360,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -419,4 +427,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h fitsfile.h \
@@ -504,4 +513,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -547,4 +557,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
@@ -577,5 +588,6 @@
   $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h fitsfile.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h fitsfile.h \
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)dvlist.h fitsinoutfile.h \
@@ -607,4 +619,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector_tsnl.h \
Index: trunk/SophyaExt/IFFTW/Makefile
===================================================================
--- trunk/SophyaExt/IFFTW/Makefile	(revision 3614)
+++ trunk/SophyaExt/IFFTW/Makefile	(revision 3615)
@@ -33,4 +33,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector.h \
Index: trunk/SophyaExt/IFFTW/smakefile
===================================================================
--- trunk/SophyaExt/IFFTW/smakefile	(revision 3614)
+++ trunk/SophyaExt/IFFTW/smakefile	(revision 3615)
@@ -33,4 +33,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector.h \
Index: trunk/SophyaExt/LinAlg/Makefile
===================================================================
--- trunk/SophyaExt/LinAlg/Makefile	(revision 3614)
+++ trunk/SophyaExt/LinAlg/Makefile	(revision 3615)
@@ -30,4 +30,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)tmatrix.h \
Index: trunk/SophyaExt/LinAlg/smakefile
===================================================================
--- trunk/SophyaExt/LinAlg/smakefile	(revision 3614)
+++ trunk/SophyaExt/LinAlg/smakefile	(revision 3615)
@@ -30,4 +30,5 @@
   $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
   $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)tmatrix.h \
Index: trunk/SophyaLib/BaseTools/Makefile
===================================================================
--- trunk/SophyaLib/BaseTools/Makefile	(revision 3614)
+++ trunk/SophyaLib/BaseTools/Makefile	(revision 3615)
@@ -4,8 +4,8 @@
  
 clean:
-	 rm -f $(SOPHYAOBJP)datatype.o $(SOPHYAOBJP)dvlist.o $(SOPHYAOBJP)fiondblock.o $(SOPHYAOBJP)mutyv.o $(SOPHYAOBJP)ndatablock.o $(SOPHYAOBJP)pexceptions.o $(SOPHYAOBJP)ppersist.o $(SOPHYAOBJP)ppfbinstream.o $(SOPHYAOBJP)ppftpointerio.o $(SOPHYAOBJP)randfmt.o $(SOPHYAOBJP)randinterf.o $(SOPHYAOBJP)randr48.o $(SOPHYAOBJP)rawstream.o $(SOPHYAOBJP)sophyainit.o $(SOPHYAOBJP)stsrand.o $(SOPHYAOBJP)timestamp.o $(SOPHYAOBJP)dSFMT.o $(SOPHYAOBJP)gnumd5.o $(SOPHYAOBJP)srandgen.o
+	 rm -f $(SOPHYAOBJP)datatype.o $(SOPHYAOBJP)dvlist.o $(SOPHYAOBJP)fiondblock.o $(SOPHYAOBJP)mutyv.o $(SOPHYAOBJP)ndatablock.o $(SOPHYAOBJP)pexceptions.o $(SOPHYAOBJP)ppersist.o $(SOPHYAOBJP)ppfbinstream.o $(SOPHYAOBJP)ppftpointerio.o $(SOPHYAOBJP)randfmt.o $(SOPHYAOBJP)randinterf.o $(SOPHYAOBJP)randr48.o $(SOPHYAOBJP)rawstream.o $(SOPHYAOBJP)sophyainit.o $(SOPHYAOBJP)stsrand.o $(SOPHYAOBJP)timestamp.o $(SOPHYAOBJP)dSFMT.o $(SOPHYAOBJP)gnumd5.o
 	rm -f $(SOPHYALIBP)libBaseTools.a
  
-$(SOPHYALIBP)libBaseTools.a : $(SOPHYAOBJP)datatype.o $(SOPHYAOBJP)dSFMT.o $(SOPHYAOBJP)dvlist.o $(SOPHYAOBJP)fiondblock.o $(SOPHYAOBJP)gnumd5.o $(SOPHYAOBJP)mutyv.o $(SOPHYAOBJP)ndatablock.o $(SOPHYAOBJP)pexceptions.o $(SOPHYAOBJP)ppersist.o $(SOPHYAOBJP)ppfbinstream.o $(SOPHYAOBJP)ppftpointerio.o $(SOPHYAOBJP)randfmt.o $(SOPHYAOBJP)randinterf.o $(SOPHYAOBJP)randr48.o $(SOPHYAOBJP)rawstream.o $(SOPHYAOBJP)sophyainit.o $(SOPHYAOBJP)srandgen.o $(SOPHYAOBJP)stsrand.o $(SOPHYAOBJP)timestamp.o
+$(SOPHYALIBP)libBaseTools.a : $(SOPHYAOBJP)datatype.o $(SOPHYAOBJP)dSFMT.o $(SOPHYAOBJP)dvlist.o $(SOPHYAOBJP)fiondblock.o $(SOPHYAOBJP)gnumd5.o $(SOPHYAOBJP)mutyv.o $(SOPHYAOBJP)ndatablock.o $(SOPHYAOBJP)pexceptions.o $(SOPHYAOBJP)ppersist.o $(SOPHYAOBJP)ppfbinstream.o $(SOPHYAOBJP)ppftpointerio.o $(SOPHYAOBJP)randfmt.o $(SOPHYAOBJP)randinterf.o $(SOPHYAOBJP)randr48.o $(SOPHYAOBJP)rawstream.o $(SOPHYAOBJP)sophyainit.o $(SOPHYAOBJP)stsrand.o $(SOPHYAOBJP)timestamp.o
 	$(AR) $(ARFLAGS) $@ $? 
 	touch $(SOPHYAINCP)/SophyaConfInfo/libsophya.objlist
@@ -84,7 +84,7 @@
   pexceptions.h ppersist.h gnumd5.h ppfbinstream.h rawstream.h \
   ppfnametag.h fiondblock.h ndatablock.h anydataobj.h dvlist.h objfio.h \
-  mutyv.h timestamp.h stsrand.h randr48.h randinterf.h randfmt.h \
-  dsfmtflags.h dSFMT.h fiosegdb.h segdatablock.h thsafeop.h \
-  ppftpointerio.h ppfwrapstlv.h sversion.h
+  mutyv.h timestamp.h randr48.h randinterf.h randfmt.h dsfmtflags.h \
+  dSFMT.h fiosegdb.h segdatablock.h thsafeop.h ppftpointerio.h \
+  ppfwrapstlv.h sversion.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sophyainit.cc
  
@@ -107,6 +107,2 @@
 	$(CCOMPILE) -o $@  gnumd5.c
  
-$(SOPHYAOBJP)srandgen.o: srandgen.c $(SOPHYAINCP)machdefs.h \
-  srandgen.h smathconst.h
-	$(CCOMPILE) -o $@  srandgen.c
- 
Index: trunk/SophyaLib/BaseTools/objlist.list
===================================================================
--- trunk/SophyaLib/BaseTools/objlist.list	(revision 3614)
+++ trunk/SophyaLib/BaseTools/objlist.list	(revision 3615)
@@ -15,5 +15,4 @@
 rawstream.o
 sophyainit.o
-srandgen.o
 stsrand.o
 timestamp.o
Index: trunk/SophyaLib/BaseTools/randfmt.cc
===================================================================
--- trunk/SophyaLib/BaseTools/randfmt.cc	(revision 3614)
+++ trunk/SophyaLib/BaseTools/randfmt.cc	(revision 3615)
@@ -19,4 +19,9 @@
 FMTRandGen::~FMTRandGen()
 {
+}
+
+void FMTRandGen::ShowRandom()
+{
+  cout<<"RandomGenerator is FMTRandGen"<<endl;
 }
 
Index: trunk/SophyaLib/BaseTools/randfmt.h
===================================================================
--- trunk/SophyaLib/BaseTools/randfmt.h	(revision 3614)
+++ trunk/SophyaLib/BaseTools/randfmt.h	(revision 3615)
@@ -30,4 +30,5 @@
   virtual void SetSeed(vector<uint_4> seed);
   virtual void AutoInit(int lp=0);
+  virtual void ShowRandom();
 
   friend class ObjFileIO<FMTRandGen> ;
Index: trunk/SophyaLib/BaseTools/randinterf.cc
===================================================================
--- trunk/SophyaLib/BaseTools/randinterf.cc	(revision 3614)
+++ trunk/SophyaLib/BaseTools/randinterf.cc	(revision 3615)
@@ -28,5 +28,5 @@
 
    \sa frand01 drand01 frandpm1 drandpm1 
-   \sa GauRnd PoissRand
+   \sa Gaussian Poisson
 
 */
@@ -62,4 +62,8 @@
 }
 
+void RandomGeneratorInterface::ShowRandom()
+{
+  cout<<"RandomGenerator is RandomGeneratorInterface i.e. UNDEFINED"<<endl;
+}
 
 /////////////////////////////////////////////////////////////////////////
@@ -172,4 +176,10 @@
 }
 
+void RandomGeneratorInterface::AutoInit(int lp)
+{
+  printf("RandomGeneratorInterface::AutoInit(): undefined code !!!\n");
+  throw MathExc("RandomGeneratorInterface::AutoInit(): undefined code !!!");
+}
+
 /////////////////////////////////////////////////////////////////////////
 /////////////////////////////////////////////////////////////////////////
@@ -773,4 +783,96 @@
 }
 
+/////////////////////////////////////////////////////////////////////////
+/////////////////////////////////////////////////////////////////////////
+/////////////////////////////////////////////////////////////////////////
+
+int RandomGeneratorInterface::Gaussian2DRho(double &x,double &y,double mx,double my,double sx,double sy,double ro)
+/*
+++
+|	Tirage de 2 nombres aleatoires x et y distribues sur une gaussienne 2D
+|	de centre (mx,my), de coefficient de correlation rho (ro) et telle que
+|	les sigmas finals des variables x et y soient sx,sy (ce sont
+|	les valeurs des distributions marginales des variables aleatoires x et y
+|	c'est a dire les sigmas des projections x et y de l'histogramme 2D
+|	de la gaussienne). Retourne 0 si ok.
+|
+| - La densite de probabilite (normalisee a 1) sur laquelle on tire est:
+|   N*exp[-0.5*{[(dx/sx)^2-2*ro/(sx*sy)*dx*dy+(dy/sy)^2]/(1-ro^2)}]
+|     avec dx = x-mx, dy = y-my et N = 1/[2Pi*sx*sy*sqrt(1-ro^2)]
+| - Dans ce cas la distribution marginale est (ex en X):
+|   1/(sqrt(2Pi)*sx) * exp[-0.5*{dx^2/sx^2}]
+| - La matrice des covariances C des variables x,y est:
+|   |   sx^2      ro*sx*sy |
+|   |                      |  et det(C) = (1-ro^2)*sx^2*sy^2
+|   | ro*sx*sy      sy^2   |
+| - La matrice inverse C^(-1) est:
+|   |   1/sx^2      -ro/(sx*sy) |
+|   |                           | * 1/(1-ro^2)
+|   | -ro/(sx*sy)      1/sy^2   |
+|
+| - Remarque:
+| le sigma que l'on obtient quand on fait une coupe de la gaussienne 2D
+| en y=0 (ou x=0) est: SX0(y=0) = sx*sqrt(1-ro^2) different de sx
+|                      SY0(x=0) = sy*sqrt(1-ro^2) different de sy
+| La distribution qui correspond a des sigmas SX0,SY0
+| pour les coupes en y=0,x=0 de la gaussienne 2D serait:
+|   N*exp[-0.5*{ (dx/SX0)^2-2*ro/(SX0*SY0)*dx*dy+(dy/SY0)^2 }]
+| avec N = sqrt(1-ro^2)/(2Pi*SX0*SY0) et les variances
+| des variables x,y sont toujours
+|  sx=SX0/sqrt(1-ro^2), sy=SY0/sqrt(1-ro^2)
+--
+*/
+{
+double a,b,sa;
+
+if( ro <= -1. || ro >= 1. ) return 1;
+
+while( (b=Flat01()) == 0. );
+b = sqrt(-2.*log(b));
+a = 2.*M_PI * Flat01();
+sa = sin(a);
+
+x = mx + sx*b*(sqrt(1.-ro*ro)*cos(a)+ro*sa);
+y = my + sy*b*sa;
+
+return 0;
+}
+
+void RandomGeneratorInterface::Gaussian2DAng(double &x,double &y,double mx,double my,double sa,double sb,double teta)
+/*
+++
+|	Tirage de 2 nombres aleatoires x et y distribues sur une gaussienne 2D
+|	de centre (x=mx,y=my), de sigmas grand axe et petit axe (sa,sb)
+|	et dont le grand axe fait un angle teta (radian) avec l'axe des x.
+|
+| - La densite de probabilite (normalisee a 1) sur laquelle on tire est:
+| N*exp[-0.5*{ (A/sa)**2+(C/sc)**2 }],  N=1/(2Pi*sa*sc)
+| ou A et B sont les coordonnees selon le grand axe et le petit axe
+| et teta = angle(x,A), le resultat subit ensuite une rotation d'angle teta.
+| - La matrice des covariances C des variables A,B est:
+|   | sa^2   0   |
+|   |            |  et det(C) = (1-ro^2)*sa^2*sb^2
+|   |  0    sb^2 |
+| - La distribution x,y resultante est:
+| N*exp[-0.5*{[(dx/sx)^2-2*ro/(sx*sy)*dx*dy+(dy/sy)^2]/(1-ro^2)}]
+| ou N est donne dans NormCo et sx,sy,ro sont calcules a partir
+| de sa,sc,teta (voir fonctions paramga ou gaparam). La matrice des
+| covariances des variables x,y est donnee dans la fonction NormCo.
+--
+*/
+{
+double c,s,X,Y;
+
+while( (s = Flat01()) == 0. );
+s = sqrt(-2.*log(s));
+c = 2.*M_PI * Flat01();
+
+X = sa*s*cos(c);
+Y = sb*s*sin(c);
+
+c = cos(teta); s = sin(teta);
+x = mx + c*X - s*Y;
+y = my + s*X + c*Y;
+}
 
 }  /* namespace SOPHYA */
@@ -780,5 +882,5 @@
 /////////////////////////////////////////////////////////////////
 /*
-**** Remarques sur complex< r_8 > ComplexGaussRan(double sig) ****
+**** Remarques sur complex< r_8 > ComplexGaussian(double sig) ****
 
 --- variables gaussiennes x,y independantes
Index: trunk/SophyaLib/BaseTools/randr48.cc
===================================================================
--- trunk/SophyaLib/BaseTools/randr48.cc	(revision 3614)
+++ trunk/SophyaLib/BaseTools/randr48.cc	(revision 3615)
@@ -16,4 +16,9 @@
 DR48RandGen::~DR48RandGen()
 {
+}
+
+void DR48RandGen::ShowRandom()
+{
+  cout<<"RandomGenerator is DR48RandGen"<<endl;
 }
 
@@ -112,4 +117,9 @@
 }
 
+
+void ThSDR48RandGen::ShowRandom()
+{
+  cout<<"RandomGenerator is ThSDR48RandGen"<<endl;
+}
 
 void ThSDR48RandGen::SetSeed(long int seed)
Index: trunk/SophyaLib/BaseTools/randr48.h
===================================================================
--- trunk/SophyaLib/BaseTools/randr48.h	(revision 3614)
+++ trunk/SophyaLib/BaseTools/randr48.h	(revision 3615)
@@ -14,4 +14,22 @@
 #include "randinterf.h"
 
+
+/* ------- SPECIFIQUE Mac Darwin OSX  <= 10.2 (gcc < 3.x) -------- */
+#if defined(Darwin) &&  defined(__GNUC__) && (__GNUC__ < 3)
+#include "osx_values.h"
+/* Declaration de drand48 et srand48 etc , mis ds SysSpec, Reza 11/02/2003 */
+#ifdef __cplusplus
+extern "C" {
+#endif
+unsigned short int * seed48(unsigned short int seed16v[3]);
+void srand48(long seedval);
+#ifdef __cplusplus
+}
+#endif
+#define drand48() ((double)(random())/LONG_MAX)
+#endif
+/* ------- FIN SPECIFIQUE Mac OSX / Darwin V <= 10.2 --------- */
+
+
 namespace SOPHYA {
 
@@ -27,4 +45,5 @@
   virtual void GetSeed(uint_2 seed[3]);
   virtual void AutoInit(int lp=0);
+  virtual void ShowRandom();
 
   friend class ObjFileIO<DR48RandGen> ;
@@ -54,4 +73,5 @@
   virtual void GetSeed(uint_2 seed[3]);
   virtual void AutoInit(int lp=0);
+  virtual void ShowRandom();
 
   friend class ObjFileIO<ThSDR48RandGen> ;
Index: trunk/SophyaLib/BaseTools/smakefile
===================================================================
--- trunk/SophyaLib/BaseTools/smakefile	(revision 3614)
+++ trunk/SophyaLib/BaseTools/smakefile	(revision 3615)
@@ -4,8 +4,8 @@
  
 clean:
-	 rm -f $(SOPHYAOBJP)datatype.o $(SOPHYAOBJP)dvlist.o $(SOPHYAOBJP)fiondblock.o $(SOPHYAOBJP)mutyv.o $(SOPHYAOBJP)ndatablock.o $(SOPHYAOBJP)pexceptions.o $(SOPHYAOBJP)ppersist.o $(SOPHYAOBJP)ppfbinstream.o $(SOPHYAOBJP)ppftpointerio.o $(SOPHYAOBJP)randfmt.o $(SOPHYAOBJP)randinterf.o $(SOPHYAOBJP)randr48.o $(SOPHYAOBJP)rawstream.o $(SOPHYAOBJP)sophyainit.o $(SOPHYAOBJP)stsrand.o $(SOPHYAOBJP)timestamp.o $(SOPHYAOBJP)dSFMT.o $(SOPHYAOBJP)gnumd5.o $(SOPHYAOBJP)srandgen.o
+	 rm -f $(SOPHYAOBJP)datatype.o $(SOPHYAOBJP)dvlist.o $(SOPHYAOBJP)fiondblock.o $(SOPHYAOBJP)mutyv.o $(SOPHYAOBJP)ndatablock.o $(SOPHYAOBJP)pexceptions.o $(SOPHYAOBJP)ppersist.o $(SOPHYAOBJP)ppfbinstream.o $(SOPHYAOBJP)ppftpointerio.o $(SOPHYAOBJP)randfmt.o $(SOPHYAOBJP)randinterf.o $(SOPHYAOBJP)randr48.o $(SOPHYAOBJP)rawstream.o $(SOPHYAOBJP)sophyainit.o $(SOPHYAOBJP)stsrand.o $(SOPHYAOBJP)timestamp.o $(SOPHYAOBJP)dSFMT.o $(SOPHYAOBJP)gnumd5.o
 	rm -f $(SOPHYALIBP)libBaseTools.a
  
-$(SOPHYALIBP)libBaseTools.a : $(SOPHYAOBJP)datatype.o $(SOPHYAOBJP)dSFMT.o $(SOPHYAOBJP)dvlist.o $(SOPHYAOBJP)fiondblock.o $(SOPHYAOBJP)gnumd5.o $(SOPHYAOBJP)mutyv.o $(SOPHYAOBJP)ndatablock.o $(SOPHYAOBJP)pexceptions.o $(SOPHYAOBJP)ppersist.o $(SOPHYAOBJP)ppfbinstream.o $(SOPHYAOBJP)ppftpointerio.o $(SOPHYAOBJP)randfmt.o $(SOPHYAOBJP)randinterf.o $(SOPHYAOBJP)randr48.o $(SOPHYAOBJP)rawstream.o $(SOPHYAOBJP)sophyainit.o $(SOPHYAOBJP)srandgen.o $(SOPHYAOBJP)stsrand.o $(SOPHYAOBJP)timestamp.o
+$(SOPHYALIBP)libBaseTools.a : $(SOPHYAOBJP)datatype.o $(SOPHYAOBJP)dSFMT.o $(SOPHYAOBJP)dvlist.o $(SOPHYAOBJP)fiondblock.o $(SOPHYAOBJP)gnumd5.o $(SOPHYAOBJP)mutyv.o $(SOPHYAOBJP)ndatablock.o $(SOPHYAOBJP)pexceptions.o $(SOPHYAOBJP)ppersist.o $(SOPHYAOBJP)ppfbinstream.o $(SOPHYAOBJP)ppftpointerio.o $(SOPHYAOBJP)randfmt.o $(SOPHYAOBJP)randinterf.o $(SOPHYAOBJP)randr48.o $(SOPHYAOBJP)rawstream.o $(SOPHYAOBJP)sophyainit.o $(SOPHYAOBJP)stsrand.o $(SOPHYAOBJP)timestamp.o
 	$(AR) $(ARFLAGS) $@ $? 
 	touch $(SOPHYAINCP)/SophyaConfInfo/libsophya.objlist
@@ -84,7 +84,7 @@
   pexceptions.h ppersist.h gnumd5.h ppfbinstream.h rawstream.h \
   ppfnametag.h fiondblock.h ndatablock.h anydataobj.h dvlist.h objfio.h \
-  mutyv.h timestamp.h stsrand.h randr48.h randinterf.h randfmt.h \
-  dsfmtflags.h dSFMT.h fiosegdb.h segdatablock.h thsafeop.h \
-  ppftpointerio.h ppfwrapstlv.h sversion.h
+  mutyv.h timestamp.h randr48.h randinterf.h randfmt.h dsfmtflags.h \
+  dSFMT.h fiosegdb.h segdatablock.h thsafeop.h ppftpointerio.h \
+  ppfwrapstlv.h sversion.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sophyainit.cc
  
@@ -107,6 +107,2 @@
 	$(CCOMPILE) -o $@  gnumd5.c
  
-$(SOPHYAOBJP)srandgen.o: srandgen.c $(SOPHYAINCP)machdefs.h \
-  srandgen.h smathconst.h
-	$(CCOMPILE) -o $@  srandgen.c
- 
